module Rik
  class Client
    
    module Session
      private
      
      def create
        @session_id ||= 
          begin
            @authorized = false
            call 'qik.session.create'
          end
      end
      
      def destroy
        call 'qik.session.destroy', @session_id if @session_id
      end
      
      def recreate
        @session_id = nil
        create
        authorize(@login, @password)
        @session_id
      end
      
      def authorize(login, password)
        raise Exception.new('Already authorized!') if @authorized
        # What happens if params nil?  
        @user_id = call 'qik.session.authorize', @session_id, login, password
        @authorized = true
        @auth_method = 'authorize'
        @login = login
        @password = password
      end
    end
  end
end
    