module Rik
   class Client
     
     module User
       
       def followers(*args)
         options = args.last.is_a?(Hash) ? args.pop : {}
         
         user = args.first || get_user_id
         
         begin
           call 'qik.user.followers', user
         rescue Rik::API::Error => error
           unless error.fault_code == 2002 
             STDERR << error
             nil
           else # invalid session lets renew
             recreate
             retry
           end
         end
       end
       
       def following(*args)
         options = args.last.is_a?(Hash) ? args.pop : {}
         
         user = args.first || get_user_id
         
         begin
           call 'qik.user.following', user
         rescue Rik::API::Error => error
           unless error.fault_code == 2002 
             STDERR << error
             nil
           else # invalid session lets renew
             recreate
             retry
           end
         end
       end
       
       def public_profile(*args)
         options = args.last.is_a?(Hash) ? args.pop : {}
         
         user = args.first || get_user_id
         
         detailed = options[:detailed] ? '_detailed' : ''
         by_id = user.is_a?(Numeric) ? '_by_id' : ''

         begin 
           call "qik.user.public#{detailed}_profile#{by_id}", user
         rescue Rik::API::Error => error
           unless error.fault_code == 2002 
             STDERR << error
             nil
           else # invalid session lets renew
             recreate
             retry
           end
         end
       end
       
       private
        def get_user_id
          recreate if @user_id.nil?
          @user_id
        end
     end
   end
 end