module Rik
  class Client
    
    module Video
      
      def public_user_streams(username)
        begin
          call 'qik.stream.public_user_streams', username
        rescue Rik::API::Error => error
          unless error.fault_code == 2002 
            STDERR << error
            nil
          else # invalid session lets renew
            recreate
            retry
          end
        end
      end
      
      def info(*args)
        options = args.last.is_a?(Hash) ? args.pop : {}
        
        video_id = args.first
        detailed = options[:detailed] 
        
        begin
          if detailed
            call 'qik.stream.info', create, video_id
          else
            call 'qik.stream.public_info', video_id
          end
        rescue Rik::API::Error => error
          unless error.fault_code == 2002 
            STDERR << error
            nil
          else # invalid session lets renew
            recreate
            retry
          end
        end
      end
    end
  end
end